diff --git a/src/tm-threads.h b/src/tm-threads.h
index ff3d956..c5b186f 100644
--- a/src/tm-threads.h
+++ b/src/tm-threads.h
@@ -2,6 +2,7 @@
 #define __TM_THREADS_H__
 
 #include "tm-modules.h"
+#include "packet-queue.h"
 
 /* ThreadVars type */
 enum {
@@ -10,10 +11,41 @@ enum {
     TVT_MAX,
 };
 
+typedef struct TmSlot_ {
+    /* function pointers */
+    TmEcode (*SlotFunc)(ThreadVars *, Packet *, void *, PacketQueue *);
+
+    TmEcode (*SlotThreadInit)(ThreadVars *, void *, void **);
+    void (*SlotThreadExitPrintStats)(ThreadVars *, void *);
+    TmEcode (*SlotThreadDeinit)(ThreadVars *, void *);
+
+    /* data storage */
+    void *slot_initdata;
+    void *slot_data;
+    PacketQueue slot_pq;
+
+    /* linked list, only used by TmVarSlot */
+    struct TmSlot_ *slot_next;
+} TmSlot;
+
+/* 1 function slot */
+typedef struct Tm1Slot_ {
+    TmSlot s;
+} Tm1Slot;
+
+/* Variable number of function slots */
+typedef struct TmVarSlot_ {
+    TmSlot *s;
+} TmVarSlot;
+
+
 extern ThreadVars *tv_root[TVT_MAX];
 
 extern SCMutex tv_root_lock;
 
+void TmqhReleasePacketsToPacketPool(PacketQueue *);
+void TmqhOutputPacketpool(ThreadVars *, Packet *);
+
 void Tm1SlotSetFunc(ThreadVars *, TmModule *, void *);
 void TmVarSlotSetFuncAppend(ThreadVars *, TmModule *, void *);
 ThreadVars *TmThreadCreate(char *, char *, char *, char *, char *, char *,
@@ -42,9 +74,86 @@ void TmThreadPause(ThreadVars *);
 void TmThreadPauseThreads(void);
 void TmThreadCheckThreadState(void);
 TmEcode TmThreadWaitOnThreadInit(void);
-inline int TmThreadsCheckFlag(ThreadVars *, uint8_t);
-inline void TmThreadsSetFlag(ThreadVars *, uint8_t);
+static inline int TmThreadsCheckFlag(ThreadVars *, uint8_t);
+static inline void TmThreadsSetFlag(ThreadVars *, uint8_t);
 ThreadVars *TmThreadsGetCallingThread(void);
 
+/** ------ inline functions ------ */
+
+static inline TmEcode TmThreadsSlotVarRun (ThreadVars *, Packet *, TmSlot *);
+
+/** \retval 1 flag is set
+ *  \retval 0 flag is not set
+ */
+static inline int TmThreadsCheckFlag(ThreadVars *tv, uint8_t flag) {
+    int r;
+    if (SCSpinLock(&tv->flags_spinlock) != 0) {
+        SCLogError(SC_ERR_SPINLOCK,"spin lock errno=%d",errno);
+        return 0;
+    }
+
+    r = (tv->flags & flag);
+   SCSpinUnlock(&tv->flags_spinlock);
+    return r;
+}
+
+static inline void TmThreadsSetFlag(ThreadVars *tv, uint8_t flag) {
+    if (SCSpinLock(&tv->flags_spinlock) != 0) {
+        SCLogError(SC_ERR_SPINLOCK,"spin lock errno=%d",errno);
+        return;
+    }
+
+    tv->flags |= flag;
+   SCSpinUnlock(&tv->flags_spinlock);
+}
+
+static inline void TmThreadsUnsetFlag(ThreadVars *tv, uint8_t flag) {
+    if (SCSpinLock(&tv->flags_spinlock) != 0) {
+        SCLogError(SC_ERR_SPINLOCK,"spin lock errno=%d",errno);
+        return;
+    }
+
+    tv->flags &= ~flag;
+   SCSpinUnlock(&tv->flags_spinlock);
+}
+
+/* separate run function so we can call it recursively */
+static inline TmEcode TmThreadsSlotVarRun (ThreadVars *tv, Packet *p, TmSlot *slot) {
+    TmEcode r = TM_ECODE_OK;
+    TmSlot *s = NULL;
+
+    for (s = slot; s != NULL; s = s->slot_next) {
+        r = s->SlotFunc(tv, p, s->slot_data, &s->slot_pq);
+        /* handle error */
+        if (r == TM_ECODE_FAILED) {
+            /* Encountered error.  Return packets to packetpool and return */
+            TmqhReleasePacketsToPacketPool(&s->slot_pq);
+            TmThreadsSetFlag(tv, THV_FAILED);
+            return TM_ECODE_FAILED;
+        }
+
+        /* handle new packets */
+        while (s->slot_pq.len > 0) {
+            Packet *extra_p = PacketDequeue(&s->slot_pq);
+
+            /* see if we need to process the packet */
+            if (s->slot_next != NULL) {
+                r = TmThreadsSlotVarRun(tv, extra_p, s->slot_next);
+                /* XXX handle error */
+                if (r == TM_ECODE_FAILED) {
+                    //printf("TmThreadsSlotVarRun: recursive TmThreadsSlotVarRun returned 1\n");
+                    TmqhReleasePacketsToPacketPool(&s->slot_pq);
+                    TmqhOutputPacketpool(tv, extra_p);
+                    TmThreadsSetFlag(tv, THV_FAILED);
+                    return TM_ECODE_FAILED;
+                }
+            }
+            tv->tmqh_out(tv, extra_p);
+        }
+    }
+
+    return TM_ECODE_OK;
+}
+
 #endif /* __TM_THREADS_H__ */
 
diff --git a/src/util-byte.c b/src/util-byte.c
index 121d822..4cfdf22 100644
--- a/src/util-byte.c
+++ b/src/util-byte.c
@@ -5,341 +5,6 @@
 
 /** \todo: Remove the fprintf errors in favor of logging */
 
-int ByteExtract(uint64_t *res, int e, uint16_t len, const uint8_t *bytes)
-{
-    uint64_t b = 0;
-    int i;
-
-    if ((e != BYTE_BIG_ENDIAN) && (e != BYTE_LITTLE_ENDIAN)) {
-        /** \todo Need standard return values */
-        return -1;
-    }
-
-    *res = 0;
-
-    /* Go through each byte and merge it into the result in the correct order */
-    /** \todo Probably a more efficient way to do this. */
-    for (i = 0; i < len; i++) {
-
-        if (e == BYTE_LITTLE_ENDIAN) {
-            b = bytes[i];
-        }
-        else {
-            b = bytes[len - i - 1];
-        }
-
-        *res |= (b << ((i & 7) << 3));
-
-    }
-
-    return len;
-}
-
-inline int ByteExtractUint64(uint64_t *res, int e, uint16_t len, const uint8_t *bytes)
-{
-    uint64_t i64;
-    int ret;
-
-    /* Uint64 is limited to 8 bytes */
-    if (len > 8) {
-        /** \todo Need standard return values */
-        return -1;
-    }
-
-    ret = ByteExtract(&i64, e, len, bytes);
-    if (ret <= 0) {
-        return ret;
-    }
-
-    *res = (uint64_t)i64;
-
-    return ret;
-}
-
-inline int ByteExtractUint32(uint32_t *res, int e, uint16_t len, const uint8_t *bytes)
-{
-    uint64_t i64;
-    int ret;
-
-    /* Uint32 is limited to 4 bytes */
-    if (len > 4) {
-        /** \todo Need standard return values */
-        return -1;
-    }
-
-    ret = ByteExtract(&i64, e, len, bytes);
-    if (ret <= 0) {
-        return ret;
-    }
-
-    *res = (uint32_t)i64;
-
-    return ret;
-}
-
-inline int ByteExtractUint16(uint16_t *res, int e, uint16_t len, const uint8_t *bytes)
-{
-    uint64_t i64;
-    int ret;
-
-    /* Uint16 is limited to 2 bytes */
-    if (len > 2) {
-        /** \todo Need standard return values */
-        return -1;
-    }
-
-    ret = ByteExtract(&i64, e, len, bytes);
-    if (ret <= 0) {
-        return ret;
-    }
-
-    *res = (uint16_t)i64;
-
-    return ret;
-}
-
-int ByteExtractString(uint64_t *res, int base, uint16_t len, const char *str)
-{
-    const char *ptr = str;
-    char *endptr = NULL;
-
-    /* 23 - This is the largest string (octal, with a zero prefix) that
-     *      will not overflow uint64_t.  The only way this length
-     *      could be over 23 and still not overflow is if it were zero
-     *      prefixed and we only support 1 byte of zero prefix for octal.
-     *
-     * "01777777777777777777777" = 0xffffffffffffffff
-     */
-    char strbuf[24];
-
-    if (len > 23) {
-        SCLogError(SC_ERR_ARG_LEN_LONG, "len too large (23 max)");
-        return -1;
-    }
-
-    if (len) {
-        /* Extract out the string so it can be null terminated */
-        memcpy(strbuf, str, len);
-        strbuf[len] = '\0';
-        ptr = strbuf;
-    }
-
-    errno = 0;
-    *res = strtoull(ptr, &endptr, base);
-
-    if (errno == ERANGE) {
-        SCLogError(SC_ERR_NUMERIC_VALUE_ERANGE, "Numeric value out of range");
-        return -1;
-    } else if (endptr == str) {
-        SCLogError(SC_ERR_INVALID_NUMERIC_VALUE, "Invalid numeric value");
-        return -1;
-    /* If there is no numeric value in the given string then strtoull(), makes
-       endptr equals to ptr and return 0 as result */
-    } else if (endptr == ptr && *res == 0) {
-        SCLogDebug("No numeric value");
-        return -1;
-    }
-    /* This will interfere with some rules that do not know the length
-     * in advance and instead are just using the max.
-     */
-#if 0
-    else if (len && *endptr != '\0') {
-        fprintf(stderr, "ByteExtractString: Extra characters following numeric value\n");
-        return -1;
-    }
-#endif
-
-    return (endptr - ptr);
-}
-
-inline int ByteExtractStringUint64(uint64_t *res, int base, uint16_t len, const char *str)
-{
-    return ByteExtractString(res, base, len, str);
-}
-
-inline int ByteExtractStringUint32(uint32_t *res, int base, uint16_t len, const char *str)
-{
-    uint64_t i64;
-    int ret;
-
-    ret = ByteExtractString(&i64, base, len, str);
-    if (ret <= 0) {
-        return ret;
-    }
-
-    *res = (uint32_t)i64;
-
-    if ((uint64_t)(*res) != i64) {
-        SCLogError(SC_ERR_NUMERIC_VALUE_ERANGE, "Numeric value out of range "
-                   "(%" PRIx64 " != %" PRIx64 ")", (uint64_t)(*res), i64);
-        return -1;
-    }
-
-    return ret;
-}
-
-inline int ByteExtractStringUint16(uint16_t *res, int base, uint16_t len, const char *str)
-{
-    uint64_t i64;
-    int ret;
-
-    ret = ByteExtractString(&i64, base, len, str);
-    if (ret <= 0) {
-        return ret;
-    }
-
-    *res = (uint16_t)i64;
-
-    if ((uint64_t)(*res) != i64) {
-        SCLogError(SC_ERR_NUMERIC_VALUE_ERANGE, "Numeric value out of range "
-                   "(%" PRIx64 " != %" PRIx64 ")", (uint64_t)(*res), i64);
-        return -1;
-    }
-
-    return ret;
-}
-
-inline int ByteExtractStringUint8(uint8_t *res, int base, uint16_t len, const char *str)
-{
-    uint64_t i64;
-    int ret;
-
-    ret = ByteExtractString(&i64, base, len, str);
-    if (ret <= 0) {
-        return ret;
-    }
-
-    *res = (uint8_t)i64;
-
-    if ((uint64_t)(*res) != i64) {
-        SCLogError(SC_ERR_NUMERIC_VALUE_ERANGE, "Numeric value out of range "
-                   "(%" PRIx64 " != %" PRIx64 ")", (uint64_t)(*res), i64);
-        return -1;
-    }
-
-    return ret;
-}
-
-int ByteExtractStringSigned(int64_t *res, int base, uint16_t len, const char *str)
-{
-    const char *ptr = str;
-    char *endptr;
-
-    /* 23 - This is the largest string (octal, with a zero prefix) that
-     *      will not overflow int64_t.  The only way this length
-     *      could be over 23 and still not overflow is if it were zero
-     *      prefixed and we only support 1 byte of zero prefix for octal.
-     *
-     * "-0777777777777777777777" = 0xffffffffffffffff
-     */
-    char strbuf[24];
-
-    if (len > 23) {
-        SCLogError(SC_ERR_ARG_LEN_LONG, "len too large (23 max)");
-        return -1;
-    }
-
-    if (len) {
-        /* Extract out the string so it can be null terminated */
-        memcpy(strbuf, str, len);
-        strbuf[len] = '\0';
-        ptr = strbuf;
-    }
-
-    errno = 0;
-    *res = strtoll(ptr, &endptr, base);
-
-    if (errno == ERANGE) {
-        SCLogError(SC_ERR_NUMERIC_VALUE_ERANGE, "Numeric value out of range");
-        return -1;
-    } else if (endptr == str) {
-        SCLogError(SC_ERR_INVALID_NUMERIC_VALUE, "Invalid numeric value");
-        return -1;
-    }
-    /* This will interfere with some rules that do not know the length
-     * in advance and instead are just using the max.
-     */
-#if 0
-    else if (len && *endptr != '\0') {
-        fprintf(stderr, "ByteExtractStringSigned: Extra characters following numeric value\n");
-        return -1;
-    }
-#endif
-
-    //fprintf(stderr, "ByteExtractStringSigned: Extracted base %d: 0x%" PRIx64 "\n", base, *res);
-
-    return (endptr - ptr);
-}
-
-inline int ByteExtractStringInt64(int64_t *res, int base, uint16_t len, const char *str)
-{
-    return ByteExtractStringSigned(res, base, len, str);
-}
-
-inline int ByteExtractStringInt32(int32_t *res, int base, uint16_t len, const char *str)
-{
-    int64_t i64;
-    int ret;
-
-    ret = ByteExtractStringSigned(&i64, base, len, str);
-    if (ret <= 0) {
-        return ret;
-    }
-
-    *res = (int32_t)i64;
-
-    if ((int64_t)(*res) != i64) {
-        SCLogError(SC_ERR_NUMERIC_VALUE_ERANGE, "Numeric value out of range "
-                   "(%" PRIx64 " != %" PRIx64 ")\n", (int64_t)(*res), i64);
-        return -1;
-    }
-
-    return ret;
-}
-
-inline int ByteExtractStringInt16(int16_t *res, int base, uint16_t len, const char *str)
-{
-    int64_t i64;
-    int ret;
-
-    ret = ByteExtractStringSigned(&i64, base, len, str);
-    if (ret <= 0) {
-        return ret;
-    }
-
-    *res = (int16_t)i64;
-
-    if ((int64_t)(*res) != i64) {
-        SCLogError(SC_ERR_NUMERIC_VALUE_ERANGE, "Numeric value out of range "
-                   "(%" PRIx64 " != %" PRIx64 ")\n", (int64_t)(*res), i64);
-        return -1;
-    }
-
-    return ret;
-}
-
-inline int ByteExtractStringInt8(int8_t *res, int base, uint16_t len, const char *str)
-{
-    int64_t i64;
-    int ret;
-
-    ret = ByteExtractStringSigned(&i64, base, len, str);
-    if (ret <= 0) {
-        return ret;
-    }
-
-    *res = (int8_t)i64;
-
-    if ((int64_t)(*res) != i64) {
-        SCLogError(SC_ERR_NUMERIC_VALUE_ERANGE, "Numeric value out of range "
-                   "(%" PRIx64 " != %" PRIx64 ")\n", (int64_t)(*res), i64);
-        return -1;
-    }
-
-    return ret;
-}
-
-/* UNITTESTS */
 #ifdef UNITTESTS
 
 static int ByteTest01 (void) {
diff --git a/src/util-byte.h b/src/util-byte.h
index ee54ffb..704fd90 100644
--- a/src/util-byte.h
+++ b/src/util-byte.h
@@ -59,7 +59,7 @@
  * \return n Number of bytes extracted on success
  * \return -1 On error
  */
-int ByteExtractUint64(uint64_t *res, int e, uint16_t len, const uint8_t *bytes);
+static inline int ByteExtractUint64(uint64_t *res, int e, uint16_t len, const uint8_t *bytes);
 
 /**
  * Extract bytes from a byte string and convert to a unint32_t.
@@ -72,7 +72,7 @@ int ByteExtractUint64(uint64_t *res, int e, uint16_t len, const uint8_t *bytes);
  * \return n Number of bytes extracted on success
  * \return -1 On error
  */
-inline int ByteExtractUint32(uint32_t *res, int e, uint16_t len, const uint8_t *bytes);
+static inline int ByteExtractUint32(uint32_t *res, int e, uint16_t len, const uint8_t *bytes);
 
 /**
  * Extract bytes from a byte string and convert to a unint16_t.
@@ -85,7 +85,7 @@ inline int ByteExtractUint32(uint32_t *res, int e, uint16_t len, const uint8_t *
  * \return n Number of bytes extracted on success
  * \return -1 On error
  */
-inline int ByteExtractUint16(uint16_t *res, int e, uint16_t len, const uint8_t *bytes);
+static inline int ByteExtractUint16(uint16_t *res, int e, uint16_t len, const uint8_t *bytes);
 
 /**
  * Extract unsigned integer value from a string.
@@ -98,7 +98,7 @@ inline int ByteExtractUint16(uint16_t *res, int e, uint16_t len, const uint8_t *
  * \return n Number of bytes extracted on success
  * \return -1 On error
  */
-inline int ByteExtractString(uint64_t *res, int base, uint16_t len, const char *str);
+static inline int ByteExtractString(uint64_t *res, int base, uint16_t len, const char *str);
 
 /**
  * Extract unsigned integer value from a string as uint64_t.
@@ -112,7 +112,7 @@ inline int ByteExtractString(uint64_t *res, int base, uint16_t len, const char *
  * \return n Number of bytes extracted on success
  * \return -1 On error
  */
-inline int ByteExtractStringUint64(uint64_t *res, int base, uint16_t len, const char *str);
+static inline int ByteExtractStringUint64(uint64_t *res, int base, uint16_t len, const char *str);
 
 /**
  * Extract unsigned integer value from a string as uint32_t.
@@ -125,7 +125,7 @@ inline int ByteExtractStringUint64(uint64_t *res, int base, uint16_t len, const
  * \return n Number of bytes extracted on success
  * \return -1 On error
  */
-inline int ByteExtractStringUint32(uint32_t *res, int base, uint16_t len, const char *str);
+static inline int ByteExtractStringUint32(uint32_t *res, int base, uint16_t len, const char *str);
 
 /**
  * Extract unsigned integer value from a string as uint16_t.
@@ -138,7 +138,7 @@ inline int ByteExtractStringUint32(uint32_t *res, int base, uint16_t len, const
  * \return n Number of bytes extracted on success
  * \return -1 On error
  */
-inline int ByteExtractStringUint16(uint16_t *res, int base, uint16_t len, const char *str);
+static inline int ByteExtractStringUint16(uint16_t *res, int base, uint16_t len, const char *str);
 
 /**
  * Extract unsigned integer value from a string as uint8_t.
@@ -151,7 +151,7 @@ inline int ByteExtractStringUint16(uint16_t *res, int base, uint16_t len, const
  * \return n Number of bytes extracted on success
  * \return -1 On error
  */
-inline int ByteExtractStringUint8(uint8_t *res, int base, uint16_t len, const char *str);
+static inline int ByteExtractStringUint8(uint8_t *res, int base, uint16_t len, const char *str);
 
 /**
  * Extract signed integer value from a string.
@@ -164,7 +164,7 @@ inline int ByteExtractStringUint8(uint8_t *res, int base, uint16_t len, const ch
  * \return n Number of bytes extracted on success
  * \return -1 On error
  */
-inline int ByteExtractStringSigned(int64_t *res, int base, uint16_t len, const char *str);
+static inline int ByteExtractStringSigned(int64_t *res, int base, uint16_t len, const char *str);
 
 /**
  * Extract signed integer value from a string as uint64_t.
@@ -177,7 +177,7 @@ inline int ByteExtractStringSigned(int64_t *res, int base, uint16_t len, const c
  * \return n Number of bytes extracted on success
  * \return -1 On error
  */
-inline int ByteExtractStringInt64(int64_t *res, int base, uint16_t len, const char *str);
+static inline int ByteExtractStringInt64(int64_t *res, int base, uint16_t len, const char *str);
 
 /**
  * Extract signed integer value from a string as uint32_t.
@@ -190,7 +190,7 @@ inline int ByteExtractStringInt64(int64_t *res, int base, uint16_t len, const ch
  * \return n Number of bytes extracted on success
  * \return -1 On error
  */
-inline int ByteExtractStringInt32(int32_t *res, int base, uint16_t len, const char *str);
+static inline int ByteExtractStringInt32(int32_t *res, int base, uint16_t len, const char *str);
 
 /**
  * Extract signed integer value from a string as uint16_t.
@@ -203,7 +203,7 @@ inline int ByteExtractStringInt32(int32_t *res, int base, uint16_t len, const ch
  * \return n Number of bytes extracted on success
  * \return -1 On error
  */
-inline int ByteExtractStringInt16(int16_t *res, int base, uint16_t len, const char *str);
+static inline int ByteExtractStringInt16(int16_t *res, int base, uint16_t len, const char *str);
 
 /**
  * Extract signed integer value from a string as uint8_t.
@@ -216,7 +216,346 @@ inline int ByteExtractStringInt16(int16_t *res, int base, uint16_t len, const ch
  * \return n Number of bytes extracted on success
  * \return -1 On error
  */
-inline int ByteExtractStringInt8(int8_t *res, int base, uint16_t len, const char *str);
+static inline int ByteExtractStringInt8(int8_t *res, int base, uint16_t len, const char *str);
+
+/** ------ Definitions of Inline functions ------ */
+
+
+static inline int ByteExtract(uint64_t *res, int e, uint16_t len, const uint8_t *bytes)
+{
+    uint64_t b = 0;
+    int i;
+
+    if ((e != BYTE_BIG_ENDIAN) && (e != BYTE_LITTLE_ENDIAN)) {
+        /** \todo Need standard return values */
+        return -1;
+    }
+
+    *res = 0;
+
+    /* Go through each byte and merge it into the result in the correct order */
+    /** \todo Probably a more efficient way to do this. */
+    for (i = 0; i < len; i++) {
+
+        if (e == BYTE_LITTLE_ENDIAN) {
+            b = bytes[i];
+        }
+        else {
+            b = bytes[len - i - 1];
+        }
+
+        *res |= (b << ((i & 7) << 3));
+
+    }
+
+    return len;
+}
+
+static inline int ByteExtractString(uint64_t *res, int base, uint16_t len, const char *str)
+{
+    const char *ptr = str;
+    char *endptr = NULL;
+
+    /* 23 - This is the largest string (octal, with a zero prefix) that
+     *      will not overflow uint64_t.  The only way this length
+     *      could be over 23 and still not overflow is if it were zero
+     *      prefixed and we only support 1 byte of zero prefix for octal.
+     *
+     * "01777777777777777777777" = 0xffffffffffffffff
+     */
+    char strbuf[24];
+
+    if (len > 23) {
+        SCLogError(SC_ERR_ARG_LEN_LONG, "len too large (23 max)");
+        return -1;
+    }
+
+    if (len) {
+        /* Extract out the string so it can be null terminated */
+        memcpy(strbuf, str, len);
+        strbuf[len] = '\0';
+        ptr = strbuf;
+    }
+
+    errno = 0;
+    *res = strtoull(ptr, &endptr, base);
+
+    if (errno == ERANGE) {
+        SCLogError(SC_ERR_NUMERIC_VALUE_ERANGE, "Numeric value out of range");
+        return -1;
+    } else if (endptr == str) {
+        SCLogError(SC_ERR_INVALID_NUMERIC_VALUE, "Invalid numeric value");
+        return -1;
+    /* If there is no numeric value in the given string then strtoull(), makes
+       endptr equals to ptr and return 0 as result */
+    } else if (endptr == ptr && *res == 0) {
+        SCLogDebug("No numeric value");
+        return -1;
+    }
+    /* This will interfere with some rules that do not know the length
+     * in advance and instead are just using the max.
+     */
+#if 0
+    else if (len && *endptr != '\0') {
+        fprintf(stderr, "ByteExtractString: Extra characters following numeric value\n");
+        return -1;
+    }
+#endif
+
+    return (endptr - ptr);
+}
+
+static inline int ByteExtractUint64(uint64_t *res, int e, uint16_t len, const uint8_t *bytes)
+{
+    uint64_t i64;
+    int ret;
+
+    /* Uint64 is limited to 8 bytes */
+    if (len > 8) {
+        /** \todo Need standard return values */
+        return -1;
+    }
+
+    ret = ByteExtract(&i64, e, len, bytes);
+    if (ret <= 0) {
+        return ret;
+    }
+
+    *res = (uint64_t)i64;
+
+    return ret;
+}
+
+static inline int ByteExtractUint32(uint32_t *res, int e, uint16_t len, const uint8_t *bytes)
+{
+    uint64_t i64;
+    int ret;
+
+    /* Uint32 is limited to 4 bytes */
+    if (len > 4) {
+        /** \todo Need standard return values */
+        return -1;
+    }
+
+    ret = ByteExtract(&i64, e, len, bytes);
+    if (ret <= 0) {
+        return ret;
+    }
+
+    *res = (uint32_t)i64;
+
+    return ret;
+}
+
+static inline int ByteExtractUint16(uint16_t *res, int e, uint16_t len, const uint8_t *bytes)
+{
+    uint64_t i64;
+    int ret;
+
+    /* Uint16 is limited to 2 bytes */
+    if (len > 2) {
+        /** \todo Need standard return values */
+        return -1;
+    }
+
+    ret = ByteExtract(&i64, e, len, bytes);
+    if (ret <= 0) {
+        return ret;
+    }
+
+    *res = (uint16_t)i64;
+
+    return ret;
+}
+
+
+static inline int ByteExtractStringInt64(int64_t *res, int base, uint16_t len, const char *str)
+{
+    return ByteExtractStringSigned(res, base, len, str);
+}
+
+static inline int ByteExtractStringInt32(int32_t *res, int base, uint16_t len, const char *str)
+{
+    int64_t i64;
+    int ret;
+
+    ret = ByteExtractStringSigned(&i64, base, len, str);
+    if (ret <= 0) {
+        return ret;
+    }
+
+    *res = (int32_t)i64;
+
+    if ((int64_t)(*res) != i64) {
+        SCLogError(SC_ERR_NUMERIC_VALUE_ERANGE, "Numeric value out of range "
+                   "(%" PRIx64 " != %" PRIx64 ")\n", (int64_t)(*res), i64);
+        return -1;
+    }
+
+    return ret;
+}
+
+static inline int ByteExtractStringInt16(int16_t *res, int base, uint16_t len, const char *str)
+{
+    int64_t i64;
+    int ret;
+
+    ret = ByteExtractStringSigned(&i64, base, len, str);
+    if (ret <= 0) {
+        return ret;
+    }
+
+    *res = (int16_t)i64;
+
+    if ((int64_t)(*res) != i64) {
+        SCLogError(SC_ERR_NUMERIC_VALUE_ERANGE, "Numeric value out of range "
+                   "(%" PRIx64 " != %" PRIx64 ")\n", (int64_t)(*res), i64);
+        return -1;
+    }
+
+    return ret;
+}
+
+static inline int ByteExtractStringInt8(int8_t *res, int base, uint16_t len, const char *str)
+{
+    int64_t i64;
+    int ret;
+
+    ret = ByteExtractStringSigned(&i64, base, len, str);
+    if (ret <= 0) {
+        return ret;
+    }
+
+    *res = (int8_t)i64;
+
+    if ((int64_t)(*res) != i64) {
+        SCLogError(SC_ERR_NUMERIC_VALUE_ERANGE, "Numeric value out of range "
+                   "(%" PRIx64 " != %" PRIx64 ")\n", (int64_t)(*res), i64);
+        return -1;
+    }
+
+    return ret;
+}
+
+static inline int ByteExtractStringUint64(uint64_t *res, int base, uint16_t len, const char *str)
+{
+    return ByteExtractString(res, base, len, str);
+}
+
+static inline int ByteExtractStringUint32(uint32_t *res, int base, uint16_t len, const char *str)
+{
+    uint64_t i64;
+    int ret;
+
+    ret = ByteExtractString(&i64, base, len, str);
+    if (ret <= 0) {
+        return ret;
+    }
+
+    *res = (uint32_t)i64;
+
+    if ((uint64_t)(*res) != i64) {
+        SCLogError(SC_ERR_NUMERIC_VALUE_ERANGE, "Numeric value out of range "
+                   "(%" PRIx64 " != %" PRIx64 ")", (uint64_t)(*res), i64);
+        return -1;
+    }
+
+    return ret;
+}
+
+static inline int ByteExtractStringUint16(uint16_t *res, int base, uint16_t len, const char *str)
+{
+    uint64_t i64;
+    int ret;
+
+    ret = ByteExtractString(&i64, base, len, str);
+    if (ret <= 0) {
+        return ret;
+    }
+
+    *res = (uint16_t)i64;
+
+    if ((uint64_t)(*res) != i64) {
+        SCLogError(SC_ERR_NUMERIC_VALUE_ERANGE, "Numeric value out of range "
+                   "(%" PRIx64 " != %" PRIx64 ")", (uint64_t)(*res), i64);
+        return -1;
+    }
+
+    return ret;
+}
+
+static inline int ByteExtractStringUint8(uint8_t *res, int base, uint16_t len, const char *str)
+{
+    uint64_t i64;
+    int ret;
+
+    ret = ByteExtractString(&i64, base, len, str);
+    if (ret <= 0) {
+        return ret;
+    }
+
+    *res = (uint8_t)i64;
+
+    if ((uint64_t)(*res) != i64) {
+        SCLogError(SC_ERR_NUMERIC_VALUE_ERANGE, "Numeric value out of range "
+                   "(%" PRIx64 " != %" PRIx64 ")", (uint64_t)(*res), i64);
+        return -1;
+    }
+
+    return ret;
+}
+
+static inline int ByteExtractStringSigned(int64_t *res, int base, uint16_t len, const char *str)
+{
+    const char *ptr = str;
+    char *endptr;
+
+    /* 23 - This is the largest string (octal, with a zero prefix) that
+     *      will not overflow int64_t.  The only way this length
+     *      could be over 23 and still not overflow is if it were zero
+     *      prefixed and we only support 1 byte of zero prefix for octal.
+     *
+     * "-0777777777777777777777" = 0xffffffffffffffff
+     */
+    char strbuf[24];
+
+    if (len > 23) {
+        SCLogError(SC_ERR_ARG_LEN_LONG, "len too large (23 max)");
+        return -1;
+    }
+
+    if (len) {
+        /* Extract out the string so it can be null terminated */
+        memcpy(strbuf, str, len);
+        strbuf[len] = '\0';
+        ptr = strbuf;
+    }
+
+    errno = 0;
+    *res = strtoll(ptr, &endptr, base);
+
+    if (errno == ERANGE) {
+        SCLogError(SC_ERR_NUMERIC_VALUE_ERANGE, "Numeric value out of range");
+        return -1;
+    } else if (endptr == str) {
+        SCLogError(SC_ERR_INVALID_NUMERIC_VALUE, "Invalid numeric value");
+        return -1;
+    }
+    /* This will interfere with some rules that do not know the length
+     * in advance and instead are just using the max.
+     */
+#if 0
+    else if (len && *endptr != '\0') {
+        fprintf(stderr, "ByteExtractStringSigned: Extra characters following numeric value\n");
+        return -1;
+    }
+#endif
+
+    //fprintf(stderr, "ByteExtractStringSigned: Extracted base %d: 0x%" PRIx64 "\n", base, *res);
+
+    return (endptr - ptr);
+}
+/* UNITTESTS */
 
 #ifdef UNITTESTS
 void ByteRegisterTests(void);
